/*****************************************************************************
* 
* The following source code is in the public domain.
* Specifically, we give to the public domain all rights for future licensing
* of the source code, all resale rights, and all publishing rights.
* 
* We ask, but do not require, that the following message be included in all
* derived works:
* 
* Portions developed at the National Center for Supercomputing Applications at
* the University of Illinois at Urbana-Champaign.
* 
* THE UNIVERSITY OF ILLINOIS GIVES NO WARRANTY, EXPRESSED OR IMPLIED, FOR THE
* SOFTWARE AND/OR DOCUMENTATION PROVIDED, INCLUDING, WITHOUT LIMITATION,
* WARRANTY OF MERCHANTABILITY AND WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE
*
* This data was developed by the NCSA Visualization Services and
* Development Group.
* 
****************************************************************************/

#ifndef CELL_TABLE_H
#define CELL_TABLE_H


CELL_ENTRY  cell_table[256] =
{
    {  0,  0, 0, 0, 0, 0, 0, 0, 0,
       0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//1
    {  1,  1, 0, 0, 0, 0, 0, 0, 0,
       3,  1, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  1, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//2
    {  1,  2, 0, 0, 0, 0, 0, 0, 0,
       3,  1,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  1,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//3
    {  2,  1, 2, 0, 0, 0, 0, 0, 0,
       4,  2, 4, 9,10, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  2, 9,10, 2, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//4
    {  1,  3, 0, 0, 0, 0, 0, 0, 0,
       3,  3, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  3, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//5
    {  2,  1, 3, 0, 0, 0, 0, 0, 0,
       6,  1, 2, 3, 4, 9,12, 0, 0, 0, 0, 0, 0,
       2,  1, 4, 9, 3, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//6
    {  2,  3, 2, 0, 0, 0, 0, 0, 0,
       4, 10,12, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 10, 3, 1,10,12, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//7
    {  3,  3, 2, 1, 0, 0, 0, 0, 0,
       5, 10,12, 4, 9, 3, 0, 0, 0, 0, 0, 0, 0,
       3, 12, 9,10, 3, 9,12, 3, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },//8
    {  1,  4, 0, 0, 0, 0, 0, 0, 0,
       3,  3,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  3,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  1, 4, 0, 0, 0, 0, 0, 0,
       4, 11, 9, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 11, 1, 3,11, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  2, 4, 0, 0, 0, 0, 0, 0,
       6,  2, 3, 4, 1,10,11, 0, 0, 0, 0, 0, 0,
       2,  2, 1,10, 4, 3,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 1, 4, 0, 0, 0, 0, 0,
       5,  9,10, 3,11, 2, 0, 0, 0, 0, 0, 0, 0,
       3, 10,11, 9, 2,11,10, 2, 3,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  4, 3, 0, 0, 0, 0, 0, 0,
       4, 12,11, 4, 2, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 12, 4, 2,12,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 4, 3, 0, 0, 0, 0, 0,
       5, 11, 9, 2,12, 1, 0, 0, 0, 0, 0, 0, 0,
       3,  9,12,11, 1,12, 9, 1, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  4, 3, 2, 0, 0, 0, 0, 0,
       5, 12,11, 1,10, 4, 0, 0, 0, 0, 0, 0, 0,
       3, 11,10,12, 4,10,11, 4, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 3, 1, 2, 0, 0, 0, 0,
       4, 12,11,10, 9, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 11, 9,10,11,10,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  1,  5, 0, 0, 0, 0, 0, 0, 0,
       3,  5, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  5, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  5, 1, 0, 0, 0, 0, 0, 0,
       4,  4, 8, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  4, 5, 1, 4, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  5, 2, 0, 0, 0, 0, 0, 0,
       6,  5,10, 1, 9, 8, 2, 0, 0, 0, 0, 0, 0,
       2,  5, 9, 8, 1,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 1, 2, 0, 0, 0, 0, 0,
       5,  4, 8,10, 2, 5, 0, 0, 0, 0, 0, 0, 0,
       3,  8, 2, 4, 5, 2, 8, 5,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  5, 3, 0, 0, 0, 0, 0, 0,
       6,  5, 9,12, 3, 8, 2, 0, 0, 0, 0, 0, 0,
       2,  5, 9, 8,12, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 1, 3, 0, 0, 0, 0, 0,
       7,  4, 8, 2,12, 5, 1, 3, 0, 0, 0, 0, 0,
       3,  2,12, 3, 4, 8, 5, 4, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  3, 2, 5, 0, 0, 0, 0, 0,
       7, 10,12, 9, 8, 3, 1, 5, 0, 0, 0, 0, 0,
       3,  9, 8, 5,10,12, 3,10, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 1, 2, 5, 0, 0, 0, 0,
       6,  3,12,10, 5, 4, 8, 0, 0, 0, 0, 0, 0,
       4,  3,10,12, 3, 8,10, 3, 4, 8,10, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  5, 4, 0, 0, 0, 0, 0, 0,
       6,  9, 4,11, 8, 5, 3, 0, 0, 0, 0, 0, 0,
       2,  9, 8, 5,11, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  4, 1, 5, 0, 0, 0, 0, 0,
       5,  1, 3, 8, 5,11, 0, 0, 0, 0, 0, 0, 0,
       3,  3, 5, 1,11, 5, 3,11, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 4, 2, 0, 0, 0, 0, 0,
       9,  8, 9, 4,11,10, 2, 5, 3, 1, 0, 0, 0,
       3, 10, 2, 1, 4, 3,11, 9, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 1, 2, 5, 0, 0, 0, 0,
       6,  3,11,10, 5, 2, 8, 0, 0, 0, 0, 0, 0,
       4, 10, 2, 3, 5,10, 3,11, 5, 3, 8, 5,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  3, 4, 5, 0, 0, 0, 0, 0,
       7,  4, 2, 8, 5,12,11, 9, 0, 0, 0, 0, 0,
       3,  8, 5, 9, 4, 2,12, 4,12,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 4, 1, 5, 0, 0, 0, 0,
       6,  2,12, 8,11, 1, 5, 0, 0, 0, 0, 0, 0,
       4, 12,11, 2,11, 5, 2, 5, 1, 2, 8, 5,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 5, 2, 3, 0, 0, 0, 0,
       8,  4,11, 8, 9,12,10, 1, 5, 0, 0, 0, 0,
       4, 11,10,12,11, 1,10, 4, 1,11, 8, 5, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  3, 2, 5, 4, 1, 0, 0, 0,
       5, 12,10, 8,11, 5, 0, 0, 0, 0, 0, 0, 0,
       3, 11,10,12,11, 5,10, 8, 5,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  1,  6, 0, 0, 0, 0, 0, 0, 0,
       3,  5, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  5, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  6, 1, 0, 0, 0, 0, 0, 0,
       6, 10, 1, 9, 5, 6, 4, 0, 0, 0, 0, 0, 0,
       2, 10, 5, 6, 9, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  2, 6, 0, 0, 0, 0, 0, 0,
       4,  6, 2, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  6, 1, 5, 6, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 2, 6, 0, 0, 0, 0, 0,
       5,  2, 4, 5, 6, 9, 0, 0, 0, 0, 0, 0, 0,
       3,  4, 6, 2, 9, 6, 4, 9, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  3, 6, 0, 0, 0, 0, 0, 0,
       6,  2,10, 6,12, 3, 5, 0, 0, 0, 0, 0, 0,
       2,  2,12, 3, 6,10, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 1, 3, 0, 0, 0, 0, 0,
       9,  5,10, 1, 9,12, 3, 6, 4, 2, 0, 0, 0,
       3, 12, 3, 2, 1, 4, 9,10, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 2, 3, 0, 0, 0, 0, 0,
       5,  1, 5,12, 3, 6, 0, 0, 0, 0, 0, 0, 0,
       3,  5, 3, 1, 6, 3, 5, 6,12, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 2, 3, 6, 0, 0, 0, 0,
       6,  4, 9,12, 6, 3, 5, 0, 0, 0, 0, 0, 0,
       4, 12, 3, 4, 6,12, 4, 9, 6, 4, 5, 6, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  4, 6, 0, 0, 0, 0, 0, 0,
       6,  3,11,10, 5, 4, 6, 0, 0, 0, 0, 0, 0,
       2,  3,11, 4,10, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  4, 1, 6, 0, 0, 0, 0, 0,
       7,  1, 3, 5, 6,11, 9,10, 0, 0, 0, 0, 0,
       3,  5, 6,10, 1, 3,11, 1,11, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 2, 4, 0, 0, 0, 0, 0,
       7,  1, 5, 3,11, 6, 2, 4, 0, 0, 0, 0, 0,
       3,  3,11, 4, 1, 5, 6, 1, 6, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 1, 2, 6, 0, 0, 0, 0,
       6,  3,11, 5, 9, 2, 6, 0, 0, 0, 0, 0, 0,
       4, 11, 9, 3, 9, 6, 3, 6, 2, 3, 5, 6, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  4, 3, 6, 0, 0, 0, 0, 0,
       7, 12,11,10, 5, 4, 2, 6, 0, 0, 0, 0, 0,
       3, 10, 5, 6,12,11, 4,12, 4, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 6, 3, 4, 0, 0, 0, 0,
       8,  1, 9, 5,10,11,12, 2, 6, 0, 0, 0, 0,
       4,  9,12,11, 9, 2,12, 1, 2, 9, 5, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 2, 3, 6, 0, 0, 0, 0,
       6,  4,11,12, 6, 1, 5, 0, 0, 0, 0, 0, 0,
       4,  4,12,11, 4, 5,12, 4, 1, 5,12, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 3, 6, 1, 2, 0, 0, 0,
       5, 11,12, 5, 9, 6, 0, 0, 0, 0, 0, 0, 0,
       3,  9,12,11, 9, 6,12, 5, 6, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  5, 6, 0, 0, 0, 0, 0, 0,
       4, 10, 9, 8, 6, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 10, 8, 6,10, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 5, 1, 0, 0, 0, 0, 0,
       5,  8, 6, 1, 4,10, 0, 0, 0, 0, 0, 0, 0,
       3,  6, 4, 8,10, 4, 6,10, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 6, 5, 0, 0, 0, 0, 0,
       5,  6, 2, 9, 8, 1, 0, 0, 0, 0, 0, 0, 0,
       3,  2, 8, 6, 1, 8, 2, 1, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 2, 5, 6, 0, 0, 0, 0,
       4,  2, 4, 6, 8, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  4, 8, 6, 4, 6, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 6, 3, 0, 0, 0, 0, 0,
       7, 10, 9,12, 3, 8, 6, 2, 0, 0, 0, 0, 0,
       3, 12, 3, 2,10, 9, 8,10, 8, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  6, 3, 1, 5, 0, 0, 0, 0,
       8, 10, 6,12, 2, 8, 4, 1, 3, 0, 0, 0, 0,
       4,  6, 4, 8, 6, 1, 4,10, 1, 6,12, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 6, 2, 3, 0, 0, 0, 0,
       6,  9, 8,12, 6, 1, 3, 0, 0, 0, 0, 0, 0,
       4,  8, 6, 9, 6, 3, 9, 3, 1, 9,12, 3, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 1, 3, 6, 2, 0, 0, 0,
       5,  8, 4,12, 6, 3, 0, 0, 0, 0, 0, 0, 0,
       3,  6, 4, 8, 6, 3, 4,12, 3, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 5, 4, 0, 0, 0, 0, 0,
       7,  8, 6, 4, 3,10, 9,11, 0, 0, 0, 0, 0,
       3,  4, 3,11, 8, 6,10, 8,10, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  6, 1, 5, 4, 0, 0, 0, 0,
       6, 10, 6, 8,11, 1, 3, 0, 0, 0, 0, 0, 0,
       4, 10, 8, 6,10, 3, 8,10, 1, 3, 8, 3,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 4, 5, 6, 0, 0, 0, 0,
       8,  1, 2, 3, 4, 6, 8, 9,11, 0, 0, 0, 0,
       4,  2, 8, 6, 2, 9, 8, 1, 9, 2, 3,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  6, 5, 4, 2, 1, 0, 0, 0,
       5,  6, 8, 3, 2,11, 0, 0, 0, 0, 0, 0, 0,
       3,  2, 8, 6, 2,11, 8, 3,11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 4, 6, 5, 0, 0, 0, 0,
       8, 12,11,10, 9, 2, 6, 4, 8, 0, 0, 0, 0,
       4, 12,11, 2,11, 4, 2,10, 8, 6,10, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  6, 5, 4, 3, 1, 0, 0, 0,
       7,  6, 8, 2, 1,11,12,10, 0, 0, 0, 0, 0,
       5,  1, 2,10, 8, 6,11,11, 6,12,12, 6, 2, 2, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 3, 6, 5, 2, 0, 0, 0,
       7, 11,12, 9, 1, 6, 8, 4, 0, 0, 0, 0, 0,
       5,  1, 9, 4,12,11, 6, 6,11, 8, 8,11, 9, 9,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  6, 5, 4, 3, 2, 1, 0, 0,
       4,  6, 8,11,12, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 11, 6,12, 8, 6,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  1,  7, 0, 0, 0, 0, 0, 0, 0,
       3,  7,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  7,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  1, 7, 0, 0, 0, 0, 0, 0,
       6,  1, 4, 6, 7, 9,12, 0, 0, 0, 0, 0, 0,
       2,  1, 4, 9, 6, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  2, 7, 0, 0, 0, 0, 0, 0,
       6, 10, 6,12, 2, 1, 7, 0, 0, 0, 0, 0, 0,
       2, 10, 2, 1,12, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 2, 7, 0, 0, 0, 0, 0,
       7,  2, 4, 6, 7, 9,10,12, 0, 0, 0, 0, 0,
       3,  6, 7,12, 2, 4, 9, 2, 9,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  7, 3, 0, 0, 0, 0, 0, 0,
       4,  2, 6, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  2, 7, 3, 2, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 3, 1, 0, 0, 0, 0, 0,
       7,  2, 6, 4, 9, 7, 3, 1, 0, 0, 0, 0, 0,
       3,  4, 9, 1, 2, 6, 7, 2, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 3, 7, 0, 0, 0, 0, 0,
       5,  3, 1, 6, 7,10, 0, 0, 0, 0, 0, 0, 0,
       3,  1, 7, 3,10, 7, 1,10, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 2, 3, 7, 0, 0, 0, 0,
       6,  4, 9, 6,10, 3, 7, 0, 0, 0, 0, 0, 0,
       4,  9,10, 4,10, 7, 4, 7, 3, 4, 6, 7,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  4, 7, 0, 0, 0, 0, 0, 0,
       6,  3,12, 7,11, 4, 6, 0, 0, 0, 0, 0, 0,
       2,  3,11, 4, 7,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 4, 7, 0, 0, 0, 0, 0,
       7, 11, 9,12, 6, 1, 3, 7, 0, 0, 0, 0, 0,
       3, 12, 6, 7,11, 9, 1,11, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 4, 7, 0, 0, 0, 0, 0,
       9,  1, 2, 3, 4, 6, 7,10,11,12, 0, 0, 0,
       3,  6, 7,12, 3,11, 4, 2, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 7, 4, 1, 0, 0, 0, 0,
       8,  2,10, 6,12, 9,11, 3, 7, 0, 0, 0, 0,
       4, 10,11, 9,10, 3,11, 2, 3,10, 6, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 3, 4, 0, 0, 0, 0, 0,
       5,  2, 6,11, 4, 7, 0, 0, 0, 0, 0, 0, 0,
       3,  6, 4, 2, 7, 4, 6, 7,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  7, 4, 3, 1, 0, 0, 0, 0,
       6,  7, 6, 2, 1,11, 9, 0, 0, 0, 0, 0, 0,
       4,  7, 2, 6, 7, 9, 2, 7,11, 9, 2, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 3, 7, 2, 0, 0, 0, 0,
       6, 11, 4, 6,10, 7, 1, 0, 0, 0, 0, 0, 0,
       4,  6, 7,11,10, 6,11, 4,10,11, 1,10, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 4, 7, 2, 3, 0, 0, 0,
       5,  9,11, 6,10, 7, 0, 0, 0, 0, 0, 0, 0,
       3, 10,11, 9,10, 7,11, 6, 7,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  7, 5, 0, 0, 0, 0, 0, 0,
       6,  6, 5, 8, 7,12, 9, 0, 0, 0, 0, 0, 0,
       2,  6, 7,12, 8, 5, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 5, 7, 0, 0, 0, 0, 0,
       7,  5, 1, 7,12, 4, 8, 6, 0, 0, 0, 0, 0,
       3,  7,12, 6, 5, 1, 4, 5, 4, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 5, 2, 0, 0, 0, 0, 0,
       9,  7, 6, 5, 8, 2, 1,12, 9,10, 0, 0, 0,
       3,  2, 1,10, 5, 9, 8, 6, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 7, 2, 1, 0, 0, 0, 0,
       8,  5, 8, 7, 6, 4, 2,10,12, 0, 0, 0, 0,
       4,  8, 2, 4, 8,10, 2, 5,10, 8, 7,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  3, 7, 5, 0, 0, 0, 0, 0,
       7,  7, 3, 5, 9, 2, 6, 8, 0, 0, 0, 0, 0,
       3,  5, 9, 8, 7, 3, 2, 7, 2, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 1, 7, 3, 0, 0, 0, 0,
       8,  5, 1, 7, 3, 8, 6, 4, 2, 0, 0, 0, 0,
       4,  5, 1, 8, 1, 4, 8, 7, 2, 6, 7, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 5, 7, 3, 0, 0, 0, 0,
       8, 10, 1, 9, 5, 3, 7, 6, 8, 0, 0, 0, 0,
       4,  1, 7, 3, 1, 6, 7,10, 6, 1, 9, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 1, 3, 7, 2, 0, 0, 0,
       7,  8, 4, 6,10, 3, 7, 5, 0, 0, 0, 0, 0,
       5, 10, 6, 5, 4, 8, 3, 3, 8, 7, 7, 8, 6, 6, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  4, 5, 7, 0, 0, 0, 0, 0,
       9,  4,11, 8, 9,12, 6, 3, 5, 7, 0, 0, 0,
       3, 12, 6, 7, 8, 5, 9,11, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 7, 5, 1, 0, 0, 0, 0,
       8, 11, 3,12, 7, 1, 5, 8, 6, 0, 0, 0, 0,
       4,  3, 5, 1, 3, 8, 5,11, 8, 3,12, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 7, 2, 5, 0, 0, 0, 0,
      12,  3,12, 7,11, 1,10, 5, 9, 4, 2, 8, 6,
       4,  3,11, 4,12, 6, 7, 1,10, 2, 5, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 7, 1, 2, 5, 0, 0, 0,
       9,  3,12, 7,11,10, 5, 2, 8, 6, 0, 0, 0,
      10,  5,10, 6, 8, 7,11, 3,12, 2,12, 3,11,12,11, 7, 7, 8, 5, 7, 5, 6,12,10, 2,12, 6,10,12, 7, 6,
    },
    {  4,  7, 5, 4, 3, 0, 0, 0, 0,
       8,  7, 6, 5, 8, 2, 4,11, 9, 0, 0, 0, 0,
       4,  6, 4, 2, 6,11, 4, 7,11, 6, 5, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  7, 3, 1, 5, 4, 0, 0, 0,
       7,  6, 2, 8,11, 1, 5, 7, 0, 0, 0, 0, 0,
       5, 11, 8, 7, 2, 6, 1, 1, 6, 5, 5, 6, 8, 8, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 5, 3, 7, 2, 0, 0, 0,
       9, 11, 8, 9, 4, 6,10, 7, 1, 5, 0, 0, 0,
      10, 10, 6, 5, 1, 9, 4,11, 8, 7, 8,11, 4, 8, 4, 9, 9, 1,10, 9,10, 5, 8, 6, 7, 8, 5, 6, 8, 9, 5,
    },
    {  6,  7, 5, 4, 3, 2, 1, 0, 0,
       6,  7, 6, 5, 8,11,10, 0, 0, 0, 0, 0, 0,
       4,  8, 7,11, 6, 5,10, 6, 7, 8, 6, 8, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  6, 7, 0, 0, 0, 0, 0, 0,
       4, 12,10, 5, 7, 0, 0, 0, 0, 0, 0, 0, 0,
       2, 12, 5, 7,12,10, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 6, 1, 0, 0, 0, 0, 0,
       7,  5, 7, 1, 4,12,10, 9, 0, 0, 0, 0, 0,
       3,  1, 4, 9, 5, 7,12, 5,12,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 6, 2, 0, 0, 0, 0, 0,
       5,  5, 7, 2, 1,12, 0, 0, 0, 0, 0, 0, 0,
       3,  7, 1, 5,12, 1, 7,12, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 6, 2, 7, 0, 0, 0, 0,
       6,  9, 4, 2,12, 5, 7, 0, 0, 0, 0, 0, 0,
       4,  9, 2, 4, 9, 7, 2, 9, 5, 7, 2, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  3, 7, 6, 0, 0, 0, 0, 0,
       5,  7, 3,10, 5, 2, 0, 0, 0, 0, 0, 0, 0,
       3,  3, 5, 7, 2, 5, 3, 2,10, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 1, 6, 7, 0, 0, 0, 0,
       8,  2, 3, 4, 1, 7, 5,10, 9, 0, 0, 0, 0,
       4,  3, 5, 7, 3,10, 5, 2,10, 3, 4, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 3, 6, 7, 0, 0, 0, 0,
       4,  3, 1, 7, 5, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  1, 5, 7, 1, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  7, 6, 1, 3, 2, 0, 0, 0,
       5,  7, 5, 4, 3, 9, 0, 0, 0, 0, 0, 0, 0,
       3,  3, 5, 7, 3, 9, 5, 4, 9, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 7, 4, 0, 0, 0, 0, 0,
       7, 12,10,11, 4, 5, 7, 3, 0, 0, 0, 0, 0,
       3, 11, 4, 3,12,10, 5,12, 5, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 4, 6, 7, 0, 0, 0, 0,
       8,  1, 3, 5, 7, 9,10,11,12, 0, 0, 0, 0,
       4,  1, 3, 9, 3,11, 9, 5,12,10, 5, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  7, 4, 2, 6, 0, 0, 0, 0,
       8, 12, 7,11, 3, 5, 1, 2, 4, 0, 0, 0, 0,
       4,  7, 1, 5, 7, 2, 1,12, 2, 7,11, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  7, 6, 1, 4, 2, 0, 0, 0,
       7,  7, 5, 3, 2, 9,11,12, 0, 0, 0, 0, 0,
       5,  2, 3,12, 5, 7, 9, 9, 7,11,11, 7, 3, 3, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 3, 7, 6, 0, 0, 0, 0,
       6, 11, 4,10, 2, 7, 5, 0, 0, 0, 0, 0, 0,
       4,  4, 2,11, 2, 5,11, 5, 7,11,10, 5, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 4, 7, 6, 3, 0, 0, 0,
       7,  9,11,10, 2, 7, 5, 1, 0, 0, 0, 0, 0,
       5,  2,10, 1,11, 9, 7, 7, 9, 5, 5, 9,10,10, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  6, 2, 4, 7, 3, 0, 0, 0,
       5,  5, 1,11, 7, 4, 0, 0, 0, 0, 0, 0, 0,
       3,  7, 1, 5, 7, 4, 1,11, 4, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  1, 4, 7, 6, 2, 3, 0, 0,
       4,  9,11, 7, 5, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  7, 9, 5,11, 9, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 6, 7, 0, 0, 0, 0, 0,
       5, 10, 9, 7,12, 8, 0, 0, 0, 0, 0, 0, 0,
       3,  9,12,10, 8,12, 9, 8, 7,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 5, 6, 7, 0, 0, 0, 0,
       6,  1, 4, 7, 8,10,12, 0, 0, 0, 0, 0, 0,
       4,  4, 8, 1, 8,12, 1,12,10, 1, 7,12, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 6, 2, 7, 0, 0, 0, 0,
       6,  9, 8, 2,12, 1, 7, 0, 0, 0, 0, 0, 0,
       4,  2, 1, 9,12, 2, 9, 8,12, 9, 7,12, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 2, 7, 5, 6, 0, 0, 0,
       5,  4, 2, 7, 8,12, 0, 0, 0, 0, 0, 0, 0,
       3,  8, 2, 4, 8,12, 2, 7,12, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 7, 6, 3, 0, 0, 0, 0,
       6,  8, 9,10, 2, 7, 3, 0, 0, 0, 0, 0, 0,
       4,  8,10, 9, 8, 3,10, 8, 7, 3,10, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  3, 7, 5, 1, 6, 0, 0, 0,
       7,  3, 7, 1,10, 8, 4, 2, 0, 0, 0, 0, 0,
       5, 10, 1, 2, 7, 3, 8, 8, 3, 4, 4, 3, 1, 1, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  3, 7, 5, 2, 6, 0, 0, 0,
       5,  3, 7, 9, 1, 8, 0, 0, 0, 0, 0, 0, 0,
       3,  1, 7, 3, 1, 8, 7, 9, 8, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  5, 1, 3, 7, 6, 2, 0, 0,
       4,  8, 4, 3, 7, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  3, 8, 7, 4, 8, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 4, 7, 6, 0, 0, 0, 0,
       8,  8, 9, 4,11,10,12, 7, 3, 0, 0, 0, 0,
       4,  9,12,10, 9, 7,12, 8, 7, 9, 4, 3,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 1, 6, 7, 5, 0, 0, 0,
       7,  3, 1, 7, 8,10,12,11, 0, 0, 0, 0, 0,
       5,  8, 7,11, 1, 3,10,10, 3,12,12, 3, 7, 7, 3,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 4, 6, 2, 7, 0, 0, 0,
       9,  9, 4,11, 8, 2,12, 1, 7, 3, 0, 0, 0,
      10, 12, 2, 3, 7,11, 8, 9, 4, 1, 4, 9, 8, 4, 8,11,11, 7,12,11,12, 3, 4, 2, 1, 4, 3, 2, 4,11, 3,
    },
    {  6,  7, 4, 2, 6, 5, 1, 0, 0,
       6, 12, 7,11, 3, 2, 8, 0, 0, 0, 0, 0, 0,
       4,  3,12, 2, 7,11, 8, 7,12, 3, 7, 3,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 6, 3, 4, 7, 0, 0, 0,
       7,  9,10,11, 7, 2, 4, 8, 0, 0, 0, 0, 0,
       5,  7,11, 8,10, 9, 2, 2, 9, 4, 4, 9,11,11, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  7, 6, 5, 4, 3, 1, 0, 0,
       6,  7, 8, 2, 1,11,10, 0, 0, 0, 0, 0, 0,
       2,  8, 7,11, 1, 2,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  4, 5, 2, 3, 7, 6, 0, 0,
       6,  4,11, 8, 9, 1, 7, 0, 0, 0, 0, 0, 0,
       4,  9, 4, 1,11, 8, 7,11, 4, 9,11, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  7, 6, 5, 4, 3, 2, 1, 0,
       3,  7, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  8, 7,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  1,  8, 0, 0, 0, 0, 0, 0, 0,
       3,  7, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  7, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  1, 8, 0, 0, 0, 0, 0, 0,
       6,  4,11, 8, 9, 1, 7, 0, 0, 0, 0, 0, 0,
       2,  4, 9, 1, 8,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  8, 2, 0, 0, 0, 0, 0, 0,
       6,  7, 8, 2, 1,11,10, 0, 0, 0, 0, 0, 0,
       2,  7, 8,11, 2, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 1, 8, 0, 0, 0, 0, 0,
       7,  9,10,11, 7, 2, 4, 8, 0, 0, 0, 0, 0,
       3, 11, 7, 8, 9,10, 2, 9, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  3, 8, 0, 0, 0, 0, 0, 0,
       6, 12, 7,11, 3, 2, 8, 0, 0, 0, 0, 0, 0,
       2, 12, 3, 2,11, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 8, 3, 0, 0, 0, 0, 0,
       9,  9, 4,11, 8, 2,12, 1, 7, 3, 0, 0, 0,
       3,  2,12, 3,11, 7, 8, 4, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 3, 8, 0, 0, 0, 0, 0,
       7,  3, 1, 7, 8,10,12,11, 0, 0, 0, 0, 0,
       3,  7, 8,11, 3, 1,10, 3,10,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 8, 1, 2, 0, 0, 0, 0,
       8,  3,12, 7,11,10, 9, 4, 8, 0, 0, 0, 0,
       4, 12, 9,10,12, 4, 9, 3, 4,12, 7, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  4, 8, 0, 0, 0, 0, 0, 0,
       4,  8, 4, 3, 7, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  8, 3, 7, 8, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 4, 1, 0, 0, 0, 0, 0,
       5,  3, 7, 9, 1, 8, 0, 0, 0, 0, 0, 0, 0,
       3,  7, 1, 3, 8, 1, 7, 8, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 4, 2, 0, 0, 0, 0, 0,
       7,  3, 7, 1,10, 8, 4, 2, 0, 0, 0, 0, 0,
       3,  1,10, 2, 3, 7, 8, 3, 8, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 4, 1, 8, 0, 0, 0, 0,
       6,  2,10, 9, 8, 3, 7, 0, 0, 0, 0, 0, 0,
       4,  2, 9,10, 2, 7, 9, 2, 3, 7, 9, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  3, 4, 8, 0, 0, 0, 0, 0,
       5,  4, 2, 7, 8,12, 0, 0, 0, 0, 0, 0, 0,
       3,  2, 8, 4,12, 8, 2,12, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 4, 3, 1, 0, 0, 0, 0,
       6,  7, 8, 2, 1,12, 9, 0, 0, 0, 0, 0, 0,
       4,  2,12, 7, 1, 2, 7, 8, 1, 7, 9, 1, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 4, 3, 2, 0, 0, 0, 0,
       6,  7, 8, 1, 4,12,10, 0, 0, 0, 0, 0, 0,
       4,  8, 4, 7, 4,10, 7,10,12, 7, 1,10, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  2, 1, 8, 3, 4, 0, 0, 0,
       5, 10, 9, 7,12, 8, 0, 0, 0, 0, 0, 0, 0,
       3, 12, 9,10,12, 8, 9, 7, 8,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  8, 5, 0, 0, 0, 0, 0, 0,
       4,  9,11, 7, 5, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  9, 7, 5, 9,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  1, 5, 8, 0, 0, 0, 0, 0,
       5,  5, 1,11, 7, 4, 0, 0, 0, 0, 0, 0, 0,
       3,  1, 7, 5, 4, 7, 1, 4,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 5, 2, 0, 0, 0, 0, 0,
       7,  9,11,10, 2, 7, 5, 1, 0, 0, 0, 0, 0,
       3, 10, 2, 1, 9,11, 7, 9, 7, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 1, 5, 8, 0, 0, 0, 0,
       6, 10, 2,11, 4, 5, 7, 0, 0, 0, 0, 0, 0,
       4,  2, 4,10, 4, 7,10, 7, 5,10,11, 7, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 8, 3, 0, 0, 0, 0, 0,
       7,  7, 5, 3, 2, 9,11,12, 0, 0, 0, 0, 0,
       3,  3, 2,12, 7, 5, 9, 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 3, 8, 5, 0, 0, 0, 0,
       8,  4, 1, 2, 3, 5, 7,11,12, 0, 0, 0, 0,
       4,  1, 7, 5, 1,11, 7, 4,11, 1, 2,12, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 5, 3, 2, 0, 0, 0, 0,
       8,  7, 5, 3, 1,11,12, 9,10, 0, 0, 0, 0,
       4,  7, 5,11, 5, 9,11, 3,10,12, 3, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  3, 2, 5, 8, 1, 0, 0, 0,
       7, 12,10,11, 4, 5, 7, 3, 0, 0, 0, 0, 0,
       5,  4,11, 3,10,12, 5, 5,12, 7, 7,12,11,11,12, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  5, 8, 4, 0, 0, 0, 0, 0,
       5,  7, 5, 4, 3, 9, 0, 0, 0, 0, 0, 0, 0,
       3,  5, 3, 7, 9, 3, 5, 9, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 8, 1, 4, 0, 0, 0, 0,
       4,  7, 5, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  5, 1, 3, 5, 3, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 2, 4, 8, 0, 0, 0, 0,
       8,  9, 5,10, 1, 7, 3, 4, 2, 0, 0, 0, 0,
       4,  5, 3, 7, 5, 4, 3, 9, 4, 5,10, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 4, 2, 5, 1, 0, 0, 0,
       5,  7, 3,10, 5, 2, 0, 0, 0, 0, 0, 0, 0,
       3,  5, 3, 7, 5, 2, 3,10, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 8, 4, 5, 0, 0, 0, 0,
       6, 12, 2, 4, 9, 7, 5, 0, 0, 0, 0, 0, 0,
       4, 12, 4, 2,12, 5, 4,12, 7, 5, 4, 5, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 8, 3, 1, 4, 0, 0, 0,
       5,  5, 7, 2, 1,12, 0, 0, 0, 0, 0, 0, 0,
       3,  1, 7, 5, 1,12, 7, 2,12, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 8, 3, 2, 4, 0, 0, 0,
       7,  5, 7, 1, 4,12,10, 9, 0, 0, 0, 0, 0,
       5,  4, 1, 9, 7, 5,12,12, 5,10,10, 5, 1, 1, 5, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  3, 2, 5, 8, 4, 1, 0, 0,
       4, 12,10, 5, 7, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  5,12, 7,10,12, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  8, 6, 0, 0, 0, 0, 0, 0,
       6,  7, 6, 5, 8,11,10, 0, 0, 0, 0, 0, 0,
       2,  7, 8,11, 5, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 1, 6, 0, 0, 0, 0, 0,
       9, 11, 8, 9, 4, 6,10, 7, 1, 5, 0, 0, 0,
       3,  6,10, 5, 9, 1, 4, 8,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  2, 6, 8, 0, 0, 0, 0, 0,
       7,  6, 2, 8,11, 1, 5, 7, 0, 0, 0, 0, 0,
       3,  8,11, 7, 6, 2, 1, 6, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 8, 6, 2, 0, 0, 0, 0,
       8,  9, 4,11, 8, 2, 6, 5, 7, 0, 0, 0, 0,
       4,  4, 6, 2, 4, 5, 6, 9, 5, 4,11, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  3, 8, 6, 0, 0, 0, 0, 0,
       9,  3,12, 7,11,10, 5, 2, 8, 6, 0, 0, 0,
       3, 10, 5, 6, 7, 8,11,12, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 3, 6, 8, 0, 0, 0, 0,
      12,  1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,
       4,  1, 4, 9, 2,12, 3, 5, 6,10, 7, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  6, 8, 3, 2, 0, 0, 0, 0,
       8,  6, 5, 8, 7, 1, 3,12,11, 0, 0, 0, 0,
       4,  5, 3, 1, 5,12, 3, 6,12, 5, 8,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 8, 2, 3, 6, 0, 0, 0,
       9,  4,11, 8, 9,12, 6, 3, 5, 7, 0, 0, 0,
      10,  6,12, 7, 5, 8, 9, 4,11, 3,11, 4, 9,11, 9, 8, 8, 5, 6, 8, 6, 7,11,12, 3,11, 7,12,11, 8, 7,
    },
    {  3,  4, 8, 6, 0, 0, 0, 0, 0,
       7,  8, 4, 6,10, 3, 7, 5, 0, 0, 0, 0, 0,
       3,  6,10, 5, 8, 4, 3, 8, 3, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 6, 1, 4, 0, 0, 0, 0,
       8,  8, 7, 6, 5, 3, 1, 9,10, 0, 0, 0, 0,
       4,  7, 1, 3, 7, 9, 1, 8, 9, 7, 6,10, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 8, 2, 6, 0, 0, 0, 0,
       8,  3, 7, 1, 5, 4, 2, 8, 6, 0, 0, 0, 0,
       4,  3, 7, 4, 7, 8, 4, 1, 6, 2, 1, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 4, 2, 6, 1, 0, 0, 0,
       7,  7, 3, 5, 9, 2, 6, 8, 0, 0, 0, 0, 0,
       5,  9, 5, 8, 3, 7, 2, 2, 7, 6, 6, 7, 5, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  3, 6, 8, 4, 0, 0, 0, 0,
       8, 12, 2,10, 6, 4, 8, 7, 5, 0, 0, 0, 0,
       4,  2, 8, 4, 2, 7, 8,12, 7, 2,10, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 6, 4, 3, 1, 0, 0, 0,
       9,  7, 6, 5, 8, 2, 1,12, 9,10, 0, 0, 0,
      10,  1, 2,10, 9, 5, 8, 7, 6,12, 6, 7, 8, 6, 8, 5, 5, 9, 1, 5, 1,10, 6, 2,12, 6,10, 2, 6, 5,10,
    },
    {  5,  6, 2, 4, 8, 3, 0, 0, 0,
       7,  5, 1, 7,12, 4, 8, 6, 0, 0, 0, 0, 0,
       5, 12, 7, 6, 1, 5, 4, 4, 5, 8, 8, 5, 7, 7, 5, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  6, 8, 3, 2, 1, 4, 0, 0,
       6,  6, 5, 8, 7,12, 9, 0, 0, 0, 0, 0, 0,
       4,  7, 6,12, 5, 8, 9, 5, 6, 7, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 5, 6, 0, 0, 0, 0, 0,
       5,  9,11, 6,10, 7, 0, 0, 0, 0, 0, 0, 0,
       3, 11,10, 9, 7,10,11, 7, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  1, 5, 6, 8, 0, 0, 0, 0,
       6,  1, 4, 6, 7,10,11, 0, 0, 0, 0, 0, 0,
       4,  6,10, 1, 7, 6, 1, 4, 7, 1,11, 7, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 5, 6, 8, 0, 0, 0, 0,
       6,  1, 2, 6, 7, 9,11, 0, 0, 0, 0, 0, 0,
       4,  1, 6, 2, 1,11, 6, 1, 9,11, 6,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  2, 6, 8, 1, 5, 0, 0, 0,
       5,  2, 6,11, 4, 7, 0, 0, 0, 0, 0, 0, 0,
       3,  4, 6, 2, 4, 7, 6,11, 7, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 3, 6, 5, 0, 0, 0, 0,
       8,  7,11, 3,12, 9,10, 6, 2, 0, 0, 0, 0,
       4, 11,10, 9,11, 6,10, 7, 6,11, 3, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 3, 5, 6, 8, 0, 0, 0,
       9,  1, 2, 3, 4, 6, 7,10,11,12, 0, 0, 0,
      10,  7, 6,12,11, 3, 4, 1, 2,10, 2, 1, 4, 2, 4, 3, 3,11, 7, 3, 7,12, 2, 6,10, 2,12, 6, 2, 3,12,
    },
    {  5,  8, 5, 2, 3, 6, 0, 0, 0,
       7, 11, 9,12, 6, 1, 3, 7, 0, 0, 0, 0, 0,
       5,  6,12, 7, 9,11, 1, 1,11, 3, 3,11,12,12,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  3, 8, 1, 2, 6, 5, 0, 0,
       6,  3,12, 7,11, 4, 6, 0, 0, 0, 0, 0, 0,
       4, 11, 3, 4,12, 7, 6,12, 3,11,12,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  6, 5, 8, 4, 0, 0, 0, 0,
       6,  6,10, 4, 9, 7, 3, 0, 0, 0, 0, 0, 0,
       4, 10, 9, 6, 9, 3, 6, 3, 7, 6, 4, 3, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 1, 6, 8, 5, 0, 0, 0,
       5,  3, 1, 6, 7,10, 0, 0, 0, 0, 0, 0, 0,
       3,  7, 1, 3, 7,10, 1, 6,10, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  2, 6, 8, 4, 5, 0, 0, 0,
       7,  2, 6, 4, 9, 7, 3, 1, 0, 0, 0, 0, 0,
       5,  9, 4, 1, 6, 2, 7, 7, 2, 3, 3, 2, 4, 4, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  2, 6, 8, 4, 1, 5, 0, 0,
       4,  2, 6, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  7, 2, 3, 6, 2, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  3, 4, 5, 6, 8, 0, 0, 0,
       7,  2, 4, 6, 7, 9,10,12, 0, 0, 0, 0, 0,
       5,  7, 6,12, 4, 2, 9, 9, 2,10,10, 2, 6, 6, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  6, 3, 1, 5, 8, 4, 0, 0,
       6, 10, 6,12, 2, 1, 7, 0, 0, 0, 0, 0, 0,
       4,  2,10, 1, 6,12, 7, 6,10, 2, 6, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  2, 3, 4, 5, 6, 8, 0, 0,
       6,  1, 4, 6, 7, 9,12, 0, 0, 0, 0, 0, 0,
       2,  4, 1, 9, 7, 6,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  8, 4, 3, 6, 5, 1, 2, 0,
       3,  7,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1, 12, 7, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  2,  8, 7, 0, 0, 0, 0, 0, 0,
       4,  6, 8,11,12, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  6,11,12, 6, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 8, 1, 0, 0, 0, 0, 0,
       7, 11,12, 9, 1, 6, 8, 4, 0, 0, 0, 0, 0,
       3,  9, 1, 4,11,12, 6,11, 6, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 7, 2, 0, 0, 0, 0, 0,
       7,  6, 8, 2, 1,11,12,10, 0, 0, 0, 0, 0,
       3,  2, 1,10, 6, 8,11, 6,11,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  2, 1, 7, 8, 0, 0, 0, 0,
       8,  2, 4, 6, 8,10,12, 9,11, 0, 0, 0, 0,
       4,  2, 4,10, 4, 9,10, 6,11,12, 6, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  8, 7, 3, 0, 0, 0, 0, 0,
       5,  6, 8, 3, 2,11, 0, 0, 0, 0, 0, 0, 0,
       3,  8, 2, 6,11, 2, 8,11, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 1, 3, 7, 0, 0, 0, 0,
       8, 11, 8, 9, 4, 6, 2, 3, 1, 0, 0, 0, 0,
       4,  8, 2, 6, 8, 3, 2,11, 3, 8, 9, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 3, 7, 2, 0, 0, 0, 0,
       6, 11, 8, 6,10, 3, 1, 0, 0, 0, 0, 0, 0,
       4, 11, 6, 8,11, 1, 6,11, 3, 1, 6, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 7, 2, 1, 3, 0, 0, 0,
       7,  8, 6, 4, 3,10, 9,11, 0, 0, 0, 0, 0,
       5,  3, 4,11, 6, 8,10,10, 8, 9, 9, 8, 4, 4, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  4, 8, 7, 0, 0, 0, 0, 0,
       5,  8, 4,12, 6, 3, 0, 0, 0, 0, 0, 0, 0,
       3,  4, 6, 8, 3, 6, 4, 3,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  7, 8, 4, 1, 0, 0, 0, 0,
       6, 12, 6, 9, 8, 3, 1, 0, 0, 0, 0, 0, 0,
       4,  6, 8,12, 8, 1,12, 1, 3,12, 9, 1, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  4, 2, 7, 8, 0, 0, 0, 0,
       8,  3, 4, 1, 2, 8, 6,12,10, 0, 0, 0, 0,
       4,  4, 6, 8, 4,12, 6, 3,12, 4, 1,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  2, 1, 8, 7, 4, 0, 0, 0,
       7, 10, 9,12, 3, 8, 6, 2, 0, 0, 0, 0, 0,
       5,  3,12, 2, 9,10, 8, 8,10, 6, 6,10,12,12,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 7, 4, 3, 0, 0, 0, 0,
       4,  6, 8, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  8, 4, 2, 8, 2, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  7, 3, 1, 8, 4, 0, 0, 0,
       5,  6, 2, 9, 8, 1, 0, 0, 0, 0, 0, 0, 0,
       3,  8, 2, 6, 8, 1, 2, 9, 1, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 7, 2, 4, 3, 0, 0, 0,
       5,  8, 6, 1, 4,10, 0, 0, 0, 0, 0, 0, 0,
       3,  4, 6, 8, 4,10, 6, 1,10, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  2, 1, 8, 7, 3, 4, 0, 0,
       4, 10, 9, 8, 6, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  8,10, 6, 9,10, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  7, 8, 5, 0, 0, 0, 0, 0,
       5, 11,12, 5, 9, 6, 0, 0, 0, 0, 0, 0, 0,
       3, 12, 9,11, 6, 9,12, 6, 5, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  7, 5, 8, 1, 0, 0, 0, 0,
       6,  6,12,11, 4, 5, 1, 0, 0, 0, 0, 0, 0,
       4,  6,11,12, 6, 1,11, 6, 5, 1,11, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  7, 2, 5, 8, 0, 0, 0, 0,
       8,  6,12, 2,10,11, 9, 5, 1, 0, 0, 0, 0,
       4, 12, 9,11,12, 5, 9, 6, 5,12, 2, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  7, 8, 1, 2, 5, 0, 0, 0,
       7, 12,11,10, 5, 4, 2, 6, 0, 0, 0, 0, 0,
       5,  5,10, 6,11,12, 4, 4,12, 2, 2,12,10,10,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 8, 7, 3, 0, 0, 0, 0,
       6,  5, 9, 3,11, 6, 2, 0, 0, 0, 0, 0, 0,
       4,  9,11, 5,11, 2, 5, 2, 6, 5, 3, 2,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 5, 7, 3, 8, 0, 0, 0,
       7,  1, 5, 3,11, 6, 2, 4, 0, 0, 0, 0, 0,
       5, 11, 3, 4, 5, 1, 6, 6, 1, 2, 2, 1, 3, 3, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  2, 3, 8, 5, 7, 0, 0, 0,
       7,  1, 3, 5, 6,11, 9,10, 0, 0, 0, 0, 0,
       5,  6, 5,10, 3, 1,11,11, 1, 9, 9, 1, 5, 5, 1,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  3, 7, 8, 1, 2, 5, 0, 0,
       6,  3,11,10, 5, 4, 6, 0, 0, 0, 0, 0, 0,
       2, 11, 3, 4, 5,10, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 8, 7, 4, 0, 0, 0, 0,
       6,  5, 9,12, 3, 6, 4, 0, 0, 0, 0, 0, 0,
       4, 12, 6, 5, 3,12, 5, 9, 3, 5, 4, 3, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 5, 7, 4, 8, 0, 0, 0,
       5,  1, 5,12, 3, 6, 0, 0, 0, 0, 0, 0, 0,
       3,  3, 5, 1, 3, 6, 5,12, 6, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 2, 8, 7, 4, 0, 0, 0,
       9,  5,10, 1, 9,12, 3, 6, 4, 2, 0, 0, 0,
      10,  3,12, 2, 4, 1, 9, 5,10, 6,10, 5, 9,10, 9, 1, 1, 4, 3, 1, 3, 2,10,12, 6,10, 2,12,10, 1, 2,
    },
    {  6,  2, 7, 4, 1, 5, 8, 0, 0,
       6,  2,10, 6,12, 3, 5, 0, 0, 0, 0, 0, 0,
       4, 12, 2, 3,10, 6, 5,10, 2,12,10,12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  3, 4, 5, 7, 8, 0, 0, 0,
       5,  2, 4, 5, 6, 9, 0, 0, 0, 0, 0, 0, 0,
       3,  6, 4, 2, 6, 9, 4, 5, 9, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  7, 3, 1, 5, 8, 4, 0, 0,
       4,  6, 2, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  1, 6, 5, 2, 6, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  2, 5, 7, 3, 4, 8, 0, 0,
       6, 10, 1, 9, 5, 6, 4, 0, 0, 0, 0, 0, 0,
       4,  5,10, 6, 1, 9, 4, 1,10, 5, 1, 5, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  5, 8, 7, 2, 1, 4, 3, 0,
       3,  5, 6,10, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  6, 5,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  3,  6, 7, 8, 0, 0, 0, 0, 0,
       5, 12,10, 8,11, 5, 0, 0, 0, 0, 0, 0, 0,
       3, 10,11,12, 5,11,10, 5, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  6, 1, 8, 7, 0, 0, 0, 0,
       8,  5,10, 1, 9,12,11, 8, 4, 0, 0, 0, 0,
       4, 10,11,12,10, 8,11, 5, 8,10, 1, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 7, 6, 2, 0, 0, 0, 0,
       6,  8,11, 2,12, 5, 1, 0, 0, 0, 0, 0, 0,
       4, 11,12, 8,12, 1, 8, 1, 5, 8, 2, 1,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  1, 2, 7, 8, 6, 0, 0, 0,
       7,  4, 2, 8, 5,12,11, 9, 0, 0, 0, 0, 0,
       5,  5, 8, 9, 2, 4,12,12, 4,11,11, 4, 8, 8, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  8, 7, 6, 3, 0, 0, 0, 0,
       6,  8,11,10, 2, 5, 3, 0, 0, 0, 0, 0, 0,
       4, 10, 5, 8, 2,10, 8,11, 2, 8, 3, 2,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 1, 7, 6, 3, 0, 0, 0,
       9,  8, 9, 4,11,10, 2, 5, 3, 1, 0, 0, 0,
      10,  2,10, 1, 3, 4,11, 8, 9, 5, 9, 8,11, 9,11, 4, 4, 3, 2, 4, 2, 1, 9,10, 5, 9, 1,10, 9, 4, 1,
    },
    {  5,  2, 3, 8, 6, 7, 0, 0, 0,
       5,  1, 3, 8, 5,11, 0, 0, 0, 0, 0, 0, 0,
       3,  5, 3, 1, 5,11, 3, 8,11, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  1, 8, 6, 2, 3, 7, 0, 0,
       6,  9, 4,11, 8, 5, 3, 0, 0, 0, 0, 0, 0,
       4,  8, 9, 5, 4,11, 3, 4, 9, 8, 4, 8,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  6, 8, 7, 4, 0, 0, 0, 0,
       6,  5,10,12, 3, 8, 4, 0, 0, 0, 0, 0, 0,
       4,  5,12,10, 5, 4,12, 5, 8, 4,12, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  6, 7, 4, 1, 8, 0, 0, 0,
       7, 10,12, 9, 8, 3, 1, 5, 0, 0, 0, 0, 0,
       5,  8, 9, 5,12,10, 3, 3,10, 1, 1,10, 9, 9,10, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 8, 6, 2, 7, 0, 0, 0,
       7,  4, 8, 2,12, 5, 1, 3, 0, 0, 0, 0, 0,
       5, 12, 2, 3, 8, 4, 5, 5, 4, 1, 1, 4, 2, 2, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  6, 2, 1, 8, 7, 4, 0, 0,
       6,  5, 9,12, 3, 8, 2, 0, 0, 0, 0, 0, 0,
       2,  9, 5, 8, 3,12, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  4, 8, 6, 3, 7, 0, 0, 0,
       5,  4, 8,10, 2, 5, 0, 0, 0, 0, 0, 0, 0,
       3,  2, 8, 4, 2, 5, 8,10, 5, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  6, 1, 8, 7, 3, 4, 0, 0,
       6,  5,10, 1, 9, 8, 2, 0, 0, 0, 0, 0, 0,
       4,  9, 5, 8,10, 1, 2,10, 5, 9,10, 9, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  4, 8, 6, 2, 3, 7, 0, 0,
       4,  4, 8, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  5, 4, 1, 8, 4, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  6, 2, 1, 8, 7, 3, 4, 0,
       3,  5, 9, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  9, 5, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  4,  5, 6, 8, 7, 0, 0, 0, 0,
       4, 10, 9,12,11, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  9,11,12, 9,12,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  7, 8, 1, 6, 5, 0, 0, 0,
       5, 12,11, 1,10, 4, 0, 0, 0, 0, 0, 0, 0,
       3, 10,11,12,10, 4,11, 1, 4,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  8, 5, 2, 7, 6, 0, 0, 0,
       5, 11, 9, 2,12, 1, 0, 0, 0, 0, 0, 0, 0,
       3, 12, 9,11,12, 1, 9, 2, 1,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  7, 8, 1, 2, 6, 5, 0, 0,
       4, 12,11, 4, 2, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  4,12, 2,11,12, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  5, 6, 3, 8, 7, 0, 0, 0,
       5,  9,10, 3,11, 2, 0, 0, 0, 0, 0, 0, 0,
       3, 11,10, 9,11, 2,10, 3, 2,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  3, 1, 6, 7, 8, 5, 0, 0,
       6,  2, 3, 4, 1,10,11, 0, 0, 0, 0, 0, 0,
       4,  1, 2,10, 3, 4,11, 3, 2, 1, 3, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  8, 5, 2, 3, 7, 6, 0, 0,
       4, 11, 9, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  1,11, 3, 9,11, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  3, 7, 8, 1, 2, 6, 5, 0,
       3,  3,11, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1, 11, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  5,  6, 7, 4, 5, 8, 0, 0, 0,
       5, 10,12, 4, 9, 3, 0, 0, 0, 0, 0, 0, 0,
       3,  9,12,10, 9, 3,12, 4, 3, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  6, 7, 4, 1, 5, 8, 0, 0,
       4, 10,12, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  3,10, 1,12,10, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  2, 4, 5, 6, 7, 8, 0, 0,
       6,  1, 2, 3, 4, 9,12, 0, 0, 0, 0, 0, 0,
       4,  4, 1, 9, 2, 3,12, 2, 1, 4, 2, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  4, 1, 2, 7, 8, 5, 6, 0,
       3,  3, 2,12, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  2, 3,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  6,  3, 4, 5, 6, 7, 8, 0, 0,
       4,  2, 4, 9,10, 0, 0, 0, 0, 0, 0, 0, 0,
       2,  9, 2,10, 4, 2, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  1, 5, 6, 3, 4, 8, 7, 0,
       3,  1,10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1, 10, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  7,  2, 3, 4, 5, 6, 7, 8, 0,
       3,  1, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       1,  4, 1, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
    {  0,  0, 0, 0, 0, 0, 0, 0, 0,
       0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    },
};

#endif

